#/usr/bin/python2.2

#TENTAR FAZER A JANELA REDIMENSIONAR DEPOIS ... POR HORA, NAO ROLOU ... 

#
# *
# *   This file is part of Lupa
# *
# *   Lupa is free software; you can redistribute it and/or modify
# *   it under the terms of the GNU General Public License as published by
# *   the Free Software Foundation; either version 2 of the License, or
# *   (at your option) any later version.
# *
# *   Lupa tributed in the hope that it will be useful,
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# *   GNU General Public License for more details.
# *
# *   You should have received a copy of the GNU General Public License
# *   along with Foobar; if not, write to the Free Software
# *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# *
# 


from Tkinter import *

from interpretador import *		

Tags_dict = None

#classe Tela - define a tela de desenho, com funcoes prontas 
#para fazer os desenhos necessarios ... 
class Tela (Canvas):

	Definicoes_Padrao = None

	#Distancia existente entre cada processo
	DISTANCIA_PROCESSO = 40
	#Distancia existente entre cada evento
	DISTANCIA_EVENTO = 27

	#Numero maximo de processos e numero maximo de eventos
	LIMPROC = 0
	LIMEVENTO = 0

	Objetos = {} #Dicionario de funcoes

	Label_Destino = None

	def __init__(self, master=None):
		
		Canvas.__init__(self, master, width=740, height=400, bg='#fff', scrollregion=(0,0,((self.LIMEVENTO+1)*self.DISTANCIA_EVENTO+50),((self.LIMPROC)*self.DISTANCIA_PROCESSO)+20))
		self.Label_Destino = StringVar()
		#Setando os handles de eventos
		self.bind("<Motion>", self.Movimento_Mouse)
		self.bind("<Enter>", self.Movimento_Mouse)
		self.bind("<Leave>", self.Limpa_Label)
		self.bind("<Button-1>", self.Clique)
	#Captura o evento de movimento do mouse e de entrada no canvas - limpa a tela no canvas


	def AlteraDefinicoes(self, definic):
		self.Definicoes_Padrao = definic
		self.LIMPROC = definic.ultimo_processo + 1
		self.LIMEVENTO = definic.ultimo_evento + 1
		#Verificando se o espaco entre as mensagens cabe na tela (o limite eh o limite de um inteiro de 2 bytes)
		temp = 30000 / self.LIMEVENTO
		if temp < self.DISTANCIA_EVENTO:
			self.DISTANCIA_EVENTO = temp
		self["scrollregion"] = (0,0,((self.LIMEVENTO+1)*self.DISTANCIA_EVENTO+50),((self.LIMPROC)*self.DISTANCIA_PROCESSO)+20)
		self.grid_propagate(0)
		
	def Movimento_Mouse(self, event):
		texto = ""
		nivel = 0
		for item in self.find_withtag("current"):
			if self.Objetos.has_key(item):
				if nivel < self.Objetos[item].Nivel():
					texto = self.Objetos[item].Texto()
					nivel = self.Objetos[item].Nivel()
		self.Label_Destino.set(texto)

	#Captura o evento Leave - Limpa a tela quando o mouse
	#Sai do canvas
	def Limpa_Label(self, event):
		self.Label_Destino.set("")

	def Clique(self, event): #Nao eh clique de grafo .. :-P
		nivel = 0
		for item in self.find_withtag("current"):
			if self.Objetos.has_key(item):
				if nivel < self.Objetos[item].Nivel():
					acao  = self.Objetos[item].Acao
					nivel = self.Objetos[item].Nivel()
		if nivel > 0:
			acao()
		

	def DesenhaProcesso(self, objeto_def):
		#desenha a linha do processo na posicao especificada. 
		altura = (objeto_def.numero_processo + 0.5) * self.DISTANCIA_PROCESSO + 20
		if objeto_def.numero_processo < 0 or objeto_def.numero_processo > self.LIMPROC: 
			return FALSE
		else:
			#Adicionando objeto no dicionario
			id = self.create_line(50, altura, (objeto_def.timestamp_morte * self.DISTANCIA_EVENTO)+50, altura, width=2, fill='#000')
			self.Objetos[id] =  objeto_def
			self.create_text(30, altura, text=objeto_def.numero_processo, anchor=E)

			return TRUE
		
	def DesenhaMensagem (self, item):
		#desenha uma mensagem indo de um processo para o outro
		#no caso, utiliza o timestamp para desenhar as flechinhas 
		#de forma bonitinha.
		passo = self.DISTANCIA_EVENTO
		altura_o = (item.processo_origem + 0.5) * self.DISTANCIA_PROCESSO + 20
		altura_d = (item.processo_destino + 0.5) * self.DISTANCIA_PROCESSO + 20
		distancia_o = item.timestamp_origem * passo + 50
		distancia_d = item.timestamp_destino * passo + 50
		if item.processo_origem < 0 or item.processo_origem > self.LIMPROC or item.processo_destino < 0 or item.processo_destino > self.LIMPROC:
			return FALSE
		elif item.timestamp_origem >= item.timestamp_destino:
			return FALSE
		elif item.timestamp_origem < 0 or item.timestamp_destino > self.LIMEVENTO:
			return FALSE
		else:
			#Agora podemos desenhar a seta
			if (item.tag_mensagem < 30000):
				id = self.create_line(distancia_o, altura_o, distancia_d, altura_d, arrow=LAST)
			else:
				id = self.create_line(distancia_o, altura_o, distancia_d, altura_d, arrow=LAST, fill="blue")
			self.Objetos[id] =  item	
	def DesenhaCheckPoint (self, item):
		#desenha um checkpoint 
		passo = self.DISTANCIA_EVENTO
		altura = (item.numero_processo + 0.5) * self.DISTANCIA_PROCESSO + 20
		if item.tipo_checkpoint == 1:
			distancia = (item.timestamp_checkpoint - 0.5) * passo + 50
		else:
			distancia = item.timestamp_checkpoint * passo + 50

		if item.tipo_checkpoint == 0:
			id = self.create_rectangle(distancia - 5, altura - 5, distancia + 4, altura + 4, fill="black")
		elif item.tipo_checkpoint == 1:
			id = self.create_rectangle(distancia - 5, altura - 5, distancia + 4, altura + 4, fill="white")
		elif item.tipo_checkpoint == 2:
			id = self.create_rectangle(distancia - 5, altura - 5, distancia + 4, altura + 4, fill="blue")
			
		if self.Definicoes_Padrao.com_numero_checkpoint:
			self.create_text(distancia, altura-7, text=item.numero_checkpoint, anchor=S)
		self.Objetos[id] =  item	
	def DesenhaMorte (self, item):
		passo = self.DISTANCIA_EVENTO



#classe Application - define o formulario principal
class Application(Frame):
	def __init__ (self, master=None, **options):
		Frame.__init__(self, master, options)
		self.master.resizable(False, False)
		self.criarMenus()
		self.criarCanvas()
		self.criarBarradeTarefas()
#		self.master.minsize(640,480)


	def criarCanvas(self):
	        #Frames desenhados para conseguir posicionar
		#os objetos na tela. Para facilitar, as scrollbars
		#estao agrupadas no mesmo frame.
		self.Desenho = Tela(self) 
		self.Desenho.grid(row=1, column=0, sticky=N+E+S+W)		

		#Posicionando as scrollbars na tela
		self.ScrollY = Scrollbar(self, orient=VERTICAL, borderwidth=2, command=self.Desenho.yview)
		self.ScrollY.grid (row=1, column=1, sticky=N+S)
		self.ScrollX = Scrollbar(self,orient=HORIZONTAL, borderwidth=2, command=self.Desenho.xview)
		self.ScrollX.grid(row=2, column=0, sticky=E+W)
		
		self.Desenho["xscrollcommand"] = self.ScrollX.set
		self.Desenho["yscrollcommand"] = self.ScrollY.set


	#Rotina que cria a barra de menus 
	def criarMenus(self):
		#Criando a barra de menus (o frame)
		self.Menubar = Frame(self, relief=RAISED, bd=2, bg="#fff")
		self.Menubar.grid(row=0, column=0, columnspan=2, sticky=NW)
		
		#Criando o botao arquivo
		self.Arquivo = Menubutton(self.Menubar, text="Arquivo", relief=FLAT)
		self.Arquivo.grid(row=0, column=0, sticky=NW)

		#criando o menu arquivo
		self.Arquivo.menu = Menu(self.Arquivo, tearoff=0, relief=FLAT)
		self.Arquivo["menu"] = self.Arquivo.menu
		self.Arquivo.menu.add_command(command=self.quit, label="Sair")

	def criarBarradeTarefas(self):
		self.ToolBar = Frame(self, relief=SUNKEN, bd=2, height=20)
		self.ToolBar.grid(row=3, column=0, columnspan=2,sticky=E+W)
		self.Texto = Label(self.ToolBar, textvariable=self.Desenho.Label_Destino,justify=LEFT)
		self.Texto.grid(row=0, column=0, sticky=E+W)


#Programa principal

app = Application(None, width=800, height=600)
app.pack_configure(anchor="nw", expand=1)
app.pack()
app.master.resizable(True, True)
app.master.title("Visualizador de Processsos")

obj_interpreta = interpretador ()

resposta = obj_interpreta.interpreta_arquivo('arquivo_teste')

if (len(resposta[0]) == 0): # Nao tem erro na interpretacao do arquivo
	obj_interpreta.desenha_tela(app.Desenho, resposta)
	app.mainloop()
else:
	for item in resposta[0]:
		print item.texto_erro
	app.quit()
