import string
from Tkinter import *
from inspect import *
from ScrolledText import ScrolledText

#
# *
# *   This file is part of Lupa
# *
# *   Lupa is free software; you can redistribute it and/or modify
# *   it under the terms of the GNU General Public License as published by
# *   the Free Software Foundation; either version 2 of the License, or
# *   (at your option) any later version.
# *
# *   Lupa tributed in the hope that it will be useful,
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# *   GNU General Public License for more details.
# *
# *   You should have received a copy of the GNU General Public License
# *   along with Foobar; if not, write to the Free Software
# *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# *
# 


Tags_dict = {}

#Classe que define uma janelinha para mostrar as informacoes so
class Info(Toplevel):
    def __init__(self, nome):
        Toplevel.__init__(self)
        self.tela = Frame(self, width=100, height=100)
        self.tela.grid()
        self.title(nome);
        self.texto = ScrolledText(self.tela, width=30, height=10)
        self.texto.grid(row = 0, column=0);
        self.barra = Frame(self.tela)
        self.barra.grid(row=1, column=0, sticky=E+W)
        self.botao = Button(self.barra, text="Sair", command=self.destroy)
        self.botao.grid(row=0, column=0)

    def AdicionaLinha(self, str):
        self.texto.insert(END, str + "\n");
        
#    def modal(self):
        #Transformando a janela em modal
#        self.grab_set()
#        self.focus_set()
#        self.wait_window()

    
class defs:
    def Texto(self):
        return ("")
    def Acao(self):
        return(0)
    def Nivel(self):
        return(0)

class instrucao_DEF(defs):

    com_numero_checkpoint = False
    ultimo_processo = 0
    ultimo_evento = 0

    def __init__(self):
        com_numero_ckeckpoint = False
        ultimo_processo = 0
        ultimo_evento = 0

class instrucao_PROC(defs):

    numero_processo = 0
    timestamp_morte = 0

    def __init__(self):
        numero_processo = 0
        timestamp_morte = 0

    def Texto(self):
        return("Processo número " + str(self.numero_processo))

    def Nivel(self):
        return(1)

class instrucao_MSG(defs):

    processo_origem = 0
    processo_destino = 0
    timestamp_origem = 0
    timestamp_destino = 0
    tag_mensagem = 0
    def Texto(self):
        return("Mensagem enviada pelo processo " + str(self.processo_origem) + " (Timestamp: " + str(self.timestamp_origem) + ") e recebida pelo processo " + str(self.processo_destino) + " (Timestamp : " + str(self.timestamp_destino) + ")")

    def Nivel(self):
        return(2)

class instrucao_CHK(defs):

    numero_processo = 0
    numero_checkpoint = 0
    timestamp_checkpoint = 0
    tipo_checkpoint = 0
    num_estados = 0
    estados = []

    def __init__(self):
        self.estados = []
        self.numero_processo = 0
        self.numero_checkpoint = 0
        self.timestamp_checkpoint = 0
        self.checkpoint_forcado = False
        self.num_estados = 0

    def Texto(self):
        if self.checkpoint_forcado:
            return("Checkpoint forçado numero " + str(self.numero_checkpoint) + " do processo " + str(self.numero_processo) + " (Timestamp: " + str(self.timestamp_checkpoint) + ")" )
        else:
            return("Checkpoint básico numero " + str(self.numero_checkpoint) + " do processo " + str(self.numero_processo) + " (Timestamp: " + str(self.timestamp_checkpoint) + ")" )

    def Nivel(self):
        return(3)


    def Acao(self):
        texto = "Checkpoint "
        if self.checkpoint_forcado:
            texto = texto + "forcado"
        else:
            texto = texto + "basico"
        w = Info(texto)

        w.AdicionaLinha("CHECKPOINT NUMERO " + str(self.numero_checkpoint))
        w.AdicionaLinha("Processo: " + str(self.numero_processo))
        w.AdicionaLinha("Timestamp: " + str(self.timestamp_checkpoint))
        if self.checkpoint_forcado:
            w.AdicionaLinha("Forçado: Sim")
        else:
            w.AdicionaLinha("Forçado: Não")
        w.AdicionaLinha("")
        w.AdicionaLinha("ESTADO")
        w.AdicionaLinha("------")
        for item in self.estados:
            w.AdicionaLinha(item.Texto())
#        w.modal()



class instrucao_MORTE(defs):

    numero_processo = 0
    timestamp_morte = 0

class erro_interpretacao:
    numero_erro = 0
    linha_erro = 0
    texto_erro = ''

class instrucao_TAG:
    tag = 0.
    texto = ""

    def __init__(self):
        self.tag = 0
        self.texto = ""
    
class checkpoint_ESTADO:
    tamanho = 0
    tag = 0
    dados = [] 

    def __init__(self):
        self.tamanho = 0
        self.tag = 0
        self.dados = []

    def Texto(self):
        if Tags_dict.has_key(self.tag):
            temp = Tags_dict[self.tag].texto + " - "
        else:
            temp = ""
        temp = temp + "Tag: " + str(self.tag)
        temp = temp + " = ("
        for item in self.dados:
            temp = temp + item + ", "
        if self.tamanho > 0:
            temp = temp[0:-2]
        temp = temp + ")"
        return(temp)
        
        

#Classe interpretador - classe que interpreta os comandos executados e chama as funcoes necessarias. 

class interpretador:

    #Rotina que interpreta o arquivo. Essa rotina so separa os dados criando uma estrutura que pode ser compreendida pelo programa
    #A responsabilidade de desenhar essa estrutura eh de outra funcao dessa mesma classe (que utiliza o objeto do tipo tela)

    def interpreta_arquivo(self, nome_arq):
        estados = 0
        tamanho = 0
        definicoes = None
        processos = {}
        mensagens = []
        checkpoints = []
        erros = []
        objeto = None
        novoestado = None
        erro = None
        linhas = 0
        for line in open (nome_arq, 'r').readlines():
            linhas = linhas + 1
            erro = None
            novoestado = None
            comando = string.split(line) #quebra a linha em pequenas instrucoes
            if len(comando) > 0: # so interpreta linhas que tenham pelo menos um comando
                if (comando[0] == 'DEF' and estados == 0): #se for um cabecalho, criar um objeto do tipo instrucao_DEF
                    if len(comando) == 2:
                        definicoes = instrucao_DEF()
                        definicoes.com_numero_checkpoint = (comando[1] == 'TRUE')
                    else:
                        erro = erro_interpretacao()
                        erro.numero_erro = 1
                        erro.linha_erro = linhas
                        erro.texto_erro = 'Numero invalido de instrucoes para o comando DEF'
                elif (comando[0] == 'PROC' and estados == 0): #ordem de desenhar processos
                    if len(comando) == 2:
                        objeto = instrucao_PROC()
                        objeto.numero_processo = int(comando[1])
                        processos[objeto.numero_processo] = objeto
                        if objeto.numero_processo > definicoes.ultimo_processo:
                            definicoes.ultimo_processo = objeto.numero_processo
                    else:
                        erro = erro_interpretacao()
                        erro.numero_erro = 1
                        erro.linha_erro = linhas
                        erro.texto_erro = 'Numero invalido de instrucoes para o comando PROC'
                elif (comando[0] == 'MSG' and estados == 0): #ordem de enviar mensagens
                    if len(comando) == 6:
                        objeto = instrucao_MSG()
                        objeto.processo_origem = int(comando[1])
                        objeto.processo_destino = int(comando[2])
                        objeto.timestamp_origem = int(comando[3])
                        objeto.timestamp_destino = int(comando[4])
                        objeto.tag_mensagem = int(comando[5])
                        mensagens.append(objeto)
                    else:
                        erro = erro_interpretacao()
                        erro.numero_erro = 1
                        erro.linha_erro = linhas
                        erro.texto_erro = 'Numero invalido de instrucoes para o comando MSG'
                elif (comando[0] == 'CHK' and estados == 0):
                    if len(comando) == 6:
                        objeto = instrucao_CHK()
                        objeto.numero_processo = int (comando[1])
                        objeto.numero_checkpoint = int (comando[2])
                        objeto.timestamp_checkpoint = int (comando[3])
                        objeto.tipo_checkpoint = int (comando[4])
                        objeto.num_estados = int (comando[5])
                        estados = int(comando[5])
                        checkpoints.append(objeto)
                    else:
                        erro = erro_interpretacao()
                        erro.numero_erro = 1
                        erro.linha_erro = linhas
                        erro.texto_erro = 'Numero invalido de instrucoes para o comando MSG'

                elif (comando[0] == 'MORTE' and estados == 0):
                    if len(comando) == 3:
                        #Setando a morte do ultimo evento
                        if int(comando[2]) > definicoes.ultimo_evento:
                            definicoes.ultimo_evento = int(comando[2])
                        #Setando a morte do processo (para que a barra possa ser desenhada para cada processo)
                        if processos.has_key(int(comando[1])):
                            processos[int(comando[1])].timestamp_morte = int(comando[2])
                        else:
                            #um processo que nao foi definido morreu
                            erro = erro_interpretacao()
                            erro.numero_erro = 3
                            erro.linha_erro = linhas
                            erro.texto_erro = 'Um processo não definido foi dado como morto'
                    else:
                    
                        erro = erro_interpretacao()
                        erro.numero_erro = 1
                        erro.linha_erro = linhas
                        erro.texto_erro = 'Numero invalido de instrucoes para o comando MORTE'

                elif (comando[0] == 'TAG' and estados == 0):
                    if len(comando) >= 3:
                        objeto = instrucao_TAG()
                        objeto.tag = int(comando[1])
                        for i in range(2, len(comando)):
                            objeto.texto = objeto.texto + comando[i] + " "
                        objeto.texto = objeto.texto[0:-1]
                        Tags_dict[objeto.tag] = objeto
                    else:
                        erro = erro_interpretacao()
                        erro.numero_erro = 1
                        erro.linha_erro = linhas
                        erro.texto_erro = 'Numero invalido de instrucoes para o comando TAG'


                elif (comando[0] == 'ESTADO' and estados > 0):
                    estados = estados - 1
                    if len(comando) >= 4:
                        #A variavel objeto ja possui uma referencia ao objeto CHK.
                        tamanho = int (comando[2])
                        if len(comando) - 3 == tamanho:
                            #tudo certo - adicionar o estado ao checkpoint
                            novoestado = checkpoint_ESTADO()
                            novoestado.tamanho = tamanho
                            novoestado.tag = int(comando[1])
                            for i in range(3, len(comando)):
                                novoestado.dados.append(comando[i])
                            objeto.estados.append(novoestado)
                        else:
                            erro = erro_interpretacao()
                            erro.numero_erro = 1
                            erro.linha_erro = linhas
                            erro.texto_erro = 'Numero invalido de dados para o comando ESTADO'
                    else:
                        erro = erro_interpretacao()
                        erro.numero_erro = 1
                        erro.linha_erro = linhas
                        erro.texto_erro = 'Numero invalido de instrucoes para o comando ESTADO'
                    
                elif (comando[0] != '#'): #Gera erro se o comando nao for um comentario. Para facilitar, nao existem comentarios de bloco.
                    erro = erro_interpretacao()
                    erro.numero_erro = 2
                    erro.linha_Erro = linhas
                    erro.texto_erro = 'Comando invalido'
                if (erro != None):
                    erros.append(erro)
        return([erros, definicoes, processos, mensagens, checkpoints])
    
    def desenha_tela (self, imagem, lista):
        padrao = None
        objeto = None
        if isinstance(lista[1], instrucao_DEF): # lendo arquivo de definicoes
            imagem.AlteraDefinicoes(lista[1])
        for item in lista[2].values(): # desenhando processos 
            imagem.DesenhaProcesso(item)
        for item in lista[3]: # desenhando mensagens
            imagem.DesenhaMensagem(item)
        for item in lista[4]: # desenhando checkpoints
            imagem.DesenhaCheckPoint(item)


