#ifndef _BUFFER_H_
#define _BUFFER_H_
#include <mpi.h>
#include <malloc.h>
#include <iostream.h>
#include <constantes.h>

/*
 *
 *   This file is part of Lupa
 *
 *   Lupa is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Lupa tributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Foobar; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


/*Classe para armazenamento do pacote de mensagens
  Deve ser utilizada para a construcao de mensagens
  Independente do tipo a ser utilizado (vetor, struct, etc .. )
  
  Criada por Raphael Marcos Menderico
  Em 24/07/2003
  Ultima Alteracao: 24/07/2003*/

typedef struct lista {
  void *vetor;
  int tipo_entrada;
  int tamanho_entrada;
  int tag;
  struct lista *ant;
  struct lista *prox;
} Lista;
 
class buffer {
 private:
  Lista *dados;
  int numero;
 public:
  buffer();
  ~buffer();
  int adiciona_pacote(void *vetor, int tipo_entrada, int tamanho_entrada, int tag);
  int remove_pacote(void **vetor, int *tipo_entrada, int *tamanho_entrada, int *tag);
  void empacota(void **buffer, int *size);
  void desempacota(void *buffer, int size);
  int tamanho_atual();
  int tag_topo();
};
#endif
