#ifndef _KT_H_
#define _KT_H_
#include "mpi.h"
#include "mensagem.h"
#include "constantes.h"

/*
 *
 *   This file is part of Lupa
 *
 *   Lupa is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Lupa tributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Foobar; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


extern MPI_Datatype tipo[12];

class kt : public mensagem {
 protected:
  /*Variaveis de controle*/

  int tamanho_vetores;
  int * ultima_msg_rec;
  int * primeira_msg_env;
  int pid;
  int emissor_primeira_req;
  int num_colaboradores;
  int ind_msg;
  /*int blocked declarado na superclasse*/
  int iniciador;

  /*Funcoes virtuais*/
  virtual int processa_recebimento(buffer *b, mensagem_status *status);
  virtual void informacoes_controle(buffer *b);
  virtual int verifica_mensagem_controle (int tag);

 public:
  kt(int *argc, char** argv[], void (*grava_estado) (buffer *estado));
  virtual ~kt();
  virtual int envia_mensagem(buffer *buf, int dest, int tag);
  virtual void tira_checkpoint_basico();
  virtual char* algoritmo_utilizado();
  virtual void inicializa_monitor();
  virtual void inicializa_processo();
};
#endif
