#include <stdio.h> 
#include <iostream.h>
#include "mensagem.h"
#include "fdi.h"
#include "mpi.h"

#define FDI_DV_TAG 30000

/*
 *
 *   This file is part of Lupa
 *
 *   Lupa is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Lupa tributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Foobar; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


/*
  Classe implementando o algoritmo BCS
  Criada por Raphael Marcos Menderico
  Criacao: 08/07/2003
  Ultima alteracao: 25/07/2003
*/

fdi::fdi(int *argc, char** argv[], void (*grava_estado) (buffer *estado)):mensagem::mensagem(argc, argv, grava_estado){
  /*A rede j foi inicializada*/
  int i;
  this->dv_size = this->tamanho_rede();
  this->dv = (int *) calloc (dv_size, sizeof(int));
  this->dv_pid = this->id_processo();
  for (i = 0; i < this->dv_size; i++) {
    this->dv[i] = 0;
  }
  this->dv[this->dv_pid]++;
}

fdi::~fdi() {
  free(dv);
}

int fdi::processa_recebimento(buffer *b, mensagem_status *status) {
  void *vetor;
  int tipo_p, tamanho_p, tag_p;
  int *dv_msg;
  int i;
  b->remove_pacote (&vetor, &tipo_p, &tamanho_p, &tag_p);
  dv_msg = ((int *)vetor);
  if (this->dv[status->source] < dv_msg[status->source]) {
    this->dv[this->dv_pid]++;
    this->take_checkpoint(1);
  }
  for (i=0; i < this->dv_size; i++) {
    if (dv_msg[i] > this->dv[i]) {
      this->dv[i] = dv_msg[i];
    }
  }
  free(dv_msg); 
  return(0);
}

void fdi::informacoes_controle(buffer *b) {
  /*Ao solicitar as informacoes de controle, isso significa que 
    um checkpoint esta sendo tirado pelo sistema*/
  b->adiciona_pacote((void *)(this->dv), MSG_INT, this->dv_size, FDI_DV_TAG);
}

void fdi::tira_checkpoint_basico() {
  this->dv[this->dv_pid]++;
  mensagem::tira_checkpoint_basico();
}

int fdi::envia_mensagem(buffer *buf, int dest, int tag) {
  /*Adicionando o relogio a mensagem enviada*/
  buf->adiciona_pacote((void *)(this->dv), MSG_INT, this->dv_size, FDI_DV_TAG);
  mensagem::envia_mensagem(buf, dest, tag);
  return(0);
}

char* fdi::algoritmo_utilizado() {
  return ("FDI\n");
}
void fdi::inicializa_monitor() {
  mensagem::inicializa_monitor();
}
void fdi::inicializa_processo() {
  mensagem::inicializa_processo();
}

