#include <fifo.h>

/*
 *
 *   This file is part of Lupa
 *
 *   Lupa is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Lupa tributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Foobar; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


fifo::fifo() {
  /*Aloca o no cabeca*/
  this->dados = (FIFO_Lista *) calloc (1, sizeof(FIFO_Lista));
  this->dados->ant = this->dados;
  this->dados->prox = this->dados;
  this->dados->vetor = NULL;
  /*Inicializa o contador*/
  this->numero = 0;
}

fifo::~fifo() {
  /*Desaloca todos os registros existentes*/
  int i, tamanho;
  void *vetor;
  tamanho = this->tamanho_atual();
  for (i=0; i<tamanho; i++) {
    vetor = this->remove();
  }
  /*Desaloca o no cabeca*/
  if (this->dados != NULL) {
    free(this->dados);
  }
}

int fifo::adiciona(void *vetor) {
  FIFO_Lista *Pacote;
  /*Aloca o novo no e inicializa os valores*/  
  Pacote = (FIFO_Lista *) calloc (1, sizeof(FIFO_Lista));
  Pacote->vetor = vetor;
  /*Adiciona no no fim da lista ligada (como se fosse uma fila)*/
  Pacote->prox = this->dados;
  Pacote->ant = this->dados->ant;
  this->dados->ant->prox = Pacote;
  this->dados->ant = Pacote;
  this->numero++;
  return (1);
}

void * fifo::remove(){
  void *vetor;
  FIFO_Lista *Pacote;
  /*Remove o no atual do topo da lista ligada*/
  if (this->numero > 0) {
    Pacote = this->dados->prox; 
    this->dados->prox = Pacote->prox;
    this->dados->prox->ant = this->dados;
    
    /*Retornando as informacoes necessarias*/
    vetor = Pacote->vetor;
    free(Pacote);
    this->numero--;
    return (vetor);
  } else {
    return (NULL);
  }
}

int fifo::tamanho_atual() {
  return (this->numero);
}

