#include <stdio.h> 
#include <iostream.h>
#include "mensagem.h"
#include "lazybcs.h"
#include "mpi.h"

#define LAZYBCS_CHECKPOINT_CLOCK_TAG 30000

/*
 *
 *   This file is part of Lupa
 *
 *   Lupa is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Lupa tributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Foobar; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


/*
  Classe implementando o algoritmo Lazy-BCS
  Criada por Raphael Marcos Menderico
  Criacao: 03/12/2003
  Ultima alteracao: 03/12/2003
*/

lazybcs::lazybcs(int *argc, char** argv[], void (*grava_estado) (buffer *estado)):mensagem::mensagem(argc, argv, grava_estado){
  this->checkpoint_clock = 0;
  this->equiv = 1; /*True*/
}

int lazybcs::processa_recebimento(buffer *b, mensagem_status *status) {
  void *vetor;
  int tipo_p, tamanho_p, tag_p;
  int chk_count_msg;
  b->remove_pacote (&vetor, &tipo_p, &tamanho_p, &tag_p);
  chk_count_msg = *((int *)vetor);
  if (chk_count_msg > this->checkpoint_clock) {
    this->checkpoint_clock++;
    this->take_checkpoint(1);
    this->checkpoint_clock = chk_count_msg;
    this->equiv = 0; /*False*/
  } else if (chk_count_msg == this->checkpoint_clock){
    this->equiv = 0; /*False*/
  }
  return(0);
}

void lazybcs::informacoes_controle(buffer *b) {
  /*Ao solicitar as informacoes de controle, isso significa que 
    um checkpoint esta sendo tirado pelo sistema*/
  b->adiciona_pacote((void *)&(this->checkpoint_clock), MSG_INT, 1, LAZYBCS_CHECKPOINT_CLOCK_TAG);
}

void lazybcs::tira_checkpoint_basico() {
  if (!(this->equiv)) {
    this->checkpoint_clock++;
    this->equiv = 1; /*True*/
  }
  mensagem::tira_checkpoint_basico();
}

int lazybcs::envia_mensagem(buffer *buf, int dest, int tag) {
  /*Adicionando o relogio a mensagem enviada*/
  buf->adiciona_pacote((void *)&(this->checkpoint_clock), MSG_INT, 1, LAZYBCS_CHECKPOINT_CLOCK_TAG);
  mensagem::envia_mensagem(buf, dest, tag);
  return(0);
}

char* lazybcs::algoritmo_utilizado() {
  return ("Lazy-BCS\n");
}
void lazybcs::inicializa_monitor() {
  mensagem::inicializa_monitor();
}
void lazybcs::inicializa_processo() {
  mensagem::inicializa_processo();
}
